/* -*- mode: c++; c-basic-offset: 4; -*- */
#include "update_list.hh"
#include "src_update.hh"

#include <stdexcept>

using namespace sends;
using namespace std;

update_list sends::UpdateList;

//======================================  Update list constructor
update_list::update_list(void) {
}

//======================================  Update list destructor
update_list::~update_list(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	delete *i;
	*i = 0;
    }
    for (update_list::thread_iterator i=mThreads.begin(); i != mThreads.end(); ++i) {
    delete (i->second);
    }
}

//======================================  Update list destructor
void 
update_list::add(const src_update& su) {
    mVect.push_back(new src_update(su));
}

void
update_list::add(const std::string& name, thread::thread_base *th) {
    std::pair<std::string, thread::thread_base*> item(name, th);
    mThreads.push_back(item);
}

//======================================  Update list destructor
void 
update_list::start_all(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	(*i)->set_detached(true);
	(*i)->start();
    }
    for (thread_iterator i=mThreads.begin(); i != mThreads.end(); ++i) {
        (i->second)->set_detached(true);
        try {
        (i->second)->start_thread();
                        } catch (std::runtime_error& e) {
        }
    }
}

//======================================  Update list destructor
void 
update_list::stop_all(void) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	(*i)->stop();
    }
    for (thread_iterator i=mThreads.begin(); i != mThreads.end(); ++i) {
        (i->second)->stop_thread();
    }
}

//======================================  Update list destructor
src_update* 
update_list::find(const std::string& suname) {
    for (update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	if ((*i)->name() == suname) return *i;
    }
    return 0;
}

thread::thread_base*
update_list::find_thread(const std::string& name) {
    for (thread_iterator i=mThreads.begin(); i != mThreads.end(); ++i) {
    if (i->first == name) return (*i).second;
    }
    return 0;
}

const thread::thread_base*
update_list::find_thread(const std::string& name) const {
    for (const_thread_iterator i=mThreads.begin(); i != mThreads.end(); ++i) {
    if (i->first == name) return (*i).second;
    }
    return 0;
}

//=======================================  Test whether a type is updated.
bool
update_list::update_type(const std::string& name) const {
    for (const_update_iterator i=mVect.begin(); i != mVect.end(); ++i) {
	if ((*i)->source_type() == name) return true;
    }
    return false;
}
